//+------------------------------------------------------------------+
//|                                                         DEMA_RLH |
//| DEMA = 2 * EMA - EMA of EMA                                      |
//| Red is EMA, Green is EMA of EMA, Yellow is DEMA                  |
//+------------------------------------------------------------------+
#property  indicator_chart_window
#property  indicator_buffers 3
#property  indicator_color1  Orange
#property  indicator_color2  Red
#property  indicator_color3  LimeGreen
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
extern int EMA_Period = 14;
//---- buffers
double Dema[], Ema[], EmaOfEma[];
//+------------------------------------------------------------------+
int init()  {
   SetIndexStyle(0,DRAW_LINE);  SetIndexBuffer(0,Ema);
   SetIndexStyle(1,DRAW_LINE);  SetIndexBuffer(1,EmaOfEma);
   SetIndexStyle(2,DRAW_LINE);  SetIndexBuffer(2,Dema);
   SetIndexDrawBegin(0,EMA_Period);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   IndicatorShortName("DEMA("+EMA_Period+")");
   return(0);
  }
//+------------------------------------------------------------------+
int start()  {
   int i, limit, counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   for(i = limit; i >= 0; i--)    Ema[i] = iMA(NULL,0,EMA_Period,0,MODE_EMA,PRICE_CLOSE,i);
   for(i = limit; i >=0; i--)     EmaOfEma[i] = iMAOnArray(Ema,Bars,EMA_Period,0,MODE_EMA,i);
   for(i = limit; i >=0; i--)     Dema[i] = 2 * Ema[i] - EmaOfEma[i];
   return(0);
}
//+------------------------------------------------------------------+